`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2024/03/25 16:00:22
// Design Name: 
// Module Name: axi_slave_mem
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module axi_slave_mem(
    clk1,     // write clk
//    clk2,     // read clk
    reset,
    WR,
    RD,
    ADDR_WR,
    ADDR_RD,
    DIN,
    cmd_s,
    chirpID,
    Nlen,     // Ã¿Ò»Ö¡Êý¾ÝµÄ³¤¶È
     
    DVALID,
    DOUT,
    ValidRange,
    data_spi_32
);
    
parameter                    MEM_WORDS = 10000;
   
input                        clk1;
input                        reset;
input                        WR;
input                        RD;
input [31:0]                 ADDR_WR;
input [31:0]                 ADDR_RD;
input [31:0]                 DIN;
input                        cmd_s;
input [4 :0]                 chirpID;
input [31:0]                 Nlen;

output                       DVALID;
output [7:0]                 DOUT;
output                       ValidRange;
output [31 : 0]             data_spi_32;

reg [32-1:0]          Mem_data [MEM_WORDS-1:0];
reg [32-1:0]          Mem_addr [MEM_WORDS-1:0];
reg                   WR_r;
wire                  WR_begin;
wire                  WR_end;
reg [32-1:0]          addr_cnt;
reg [32-1:0]          DIN_r;
reg [32-1:0]          ADDR_WR_r;


always @(posedge clk1)
begin
  if (reset)
  begin
    WR_r      <= 1'b0; 
    DIN_r     <= 1'b0; 
    ADDR_WR_r <= 1'b0;
  end
  else if(RD == 1'b0) // write
  begin
   WR_r      <= WR;
   DIN_r     <= DIN;    // when need to write, just write the data_in in to memory
   ADDR_WR_r <= ADDR_WR;
  end
  else                 // read
  begin
    WR_r      <= WR;
    DIN_r     <= DIN;    // when need to write, just write the data_in in to memory
    ADDR_WR_r <= ADDR_RD;
  end
end
assign WR_begin = WR & (~WR_r);
assign WR_end = (~WR) & (WR_r);

always @(posedge clk1)
begin
  if (WR_begin)
  begin
    addr_cnt <= 32'b0;
  end
  else if(WR_r)    // ´æ´¢Êý¾ÝºÍµØÖ·
  begin
    addr_cnt <= addr_cnt + 1'b1;
    Mem_data[addr_cnt] <= DIN_r;    // when need to write, just write the data_in in to memory
    Mem_addr[addr_cnt] <= ADDR_WR_r;
  end
end

wire [31 : 0] Length; //È·¶¨Ö¡³¤¶È
//assign Length = (cmd_s == 1'b0) ? 5'd2 : 5'd17;
assign Length = Nlen + 1'b1;

reg [6 : 0] data32_cnt;     // 32bit data counter [5 : 0]--> 2·ÖÆµ£»[6 : 0]--> 4·ÖÆµ
reg [31 : 0] length_cnt;     // 32bit data counter

always@(posedge clk1)
begin
    if(reset || WR_end)
    begin
        data32_cnt <= 5'b0;
    end
    else if(length_cnt == Length)
    begin
        data32_cnt <= 5'b0;
    end
    else
    begin
        data32_cnt <= data32_cnt + 1'b1;
    end 
end
always@(posedge clk1)
begin
    if(reset || WR_end)
    begin
        length_cnt <= 32'b0;
    end
    else if(data32_cnt == 7'd127)  // 63--> 2·ÖÆµ£»127--> 4·ÖÆµ
    begin
        length_cnt <= length_cnt + 1'b1;
    end
    else if((length_cnt == Length) && (data32_cnt == 5'd0))
    begin
        length_cnt <= 32'b0;
    end 
end
reg [31 : 0] length_cnt_r;
always@(posedge clk1)
begin
    if(reset || WR_end)
    begin
        length_cnt_r <= 32'b0;
    end
    else
    begin
        length_cnt_r <= length_cnt;
    end
    
end

reg valid_32;     // Ã¿32bit¶ÔÓ¦Ò»¸övalid
reg valid_32r;
always@(posedge clk1)
begin
    if(reset || WR_end || (length_cnt == Length))
    begin
        valid_32 <= 1'b0;
        valid_32r <= 1'b0;
    end
    else if(data32_cnt == 5'd1)
    begin
        valid_32 <= 1'b1;
        valid_32r <= valid_32;
    end
    else
    begin
        valid_32 <= 1'b0;
        valid_32r <= valid_32;
    end    
end

reg [31 : 0] data_spi_32;
reg [31 : 0] data_addr_cnt;
reg [31 : 0] data_addr;
reg [31 : 0] data_mem;

always@(posedge clk1)
begin
    if(reset || WR_end || WR_begin)
    begin
        data_addr_cnt <= 32'b0;
        data_spi_32 <= 32'b0;
        data_addr <= 32'b0;
        data_mem <= 32'b0;
    end
    else if(RD == 1'b0)
    begin
    if (data_addr_cnt <= addr_cnt)
    begin
        if((data32_cnt == 5'd0) && (length_cnt != 1'b1) && (length_cnt != Length))
        begin
            data_addr_cnt <= data_addr_cnt + 32'b1;
            data_addr <= Mem_addr[data_addr_cnt];
            data_mem  <= Mem_data[data_addr_cnt];
        end
        if((data32_cnt == 5'd1) && (length_cnt == 1'b0)) // zhentou
        begin
//            data_spi_32 <= {1'b0, cmd_s,data_addr[24 : 0], 5'b0 };
            data_spi_32 <= {1'b0,data_addr[24 : 0], chirpID, 1'b0 };
        end
        else if((data32_cnt == 5'd1)) // && (length_cnt == Length - 1)
        begin
            data_spi_32 <= data_mem;
        end  
    end 
    else
    begin
        data_addr <= 32'hffff;
        data_spi_32 <= 32'hffff;
    end 
    end
    else if(RD == 1'b1)
    begin
        if (data_addr_cnt <= addr_cnt)
        begin
            if((data32_cnt == 5'd0) && (length_cnt != 1'b1) && (length_cnt != Length))
            begin
                data_addr_cnt <= data_addr_cnt + 32'b1;
                data_addr <= Mem_addr[data_addr_cnt];
            end
            if((data32_cnt == 5'd1) && (length_cnt == 1'b0)) // zhentou
            begin
//                data_spi_32 <= {1'b1, cmd_s,data_addr[24 : 0], 5'b0 };
                data_spi_32 <= {1'b1,data_addr[24 : 0], chirpID, 1'b0 };
            end
            else if((data32_cnt == 5'd1)) // && (length_cnt == Length - 1)
            begin
                data_spi_32 <= 32'b0;
            end  
        end 
        else
        begin
            data_addr <= 32'hffff;
            data_spi_32 <= 32'hffff;
        end 
    end
end

reg ss_wr;
always@(posedge clk1)
begin
    if(reset || WR_begin || (data_addr_cnt > addr_cnt))  // ÔÚÐ´Ê±²»ÔÊÐí´«Êý 
    begin
        ss_wr <= 1'b1;
    end
    else if ((WR_end))  
    begin
        ss_wr <= 1'b0;
    end 
end
reg ss_dr;
always@(posedge clk1)
begin
    if(length_cnt_r == Length)  // Ã¿´«ÍêÒ»Ö¡£¬ssÀ­µÍÒ»¸öclk
    begin
        ss_dr <= 1'b1;
    end
    else 
    begin
        ss_dr <= 1'b0;
    end 
end
reg ss_wr1;
reg ss_wr2;
always@(posedge clk1)
begin
    if(reset || (data_addr_cnt > addr_cnt))  
    begin
        ss_wr1 <= 1'b1;
        ss_wr2 <= 1'b1;
    end
    else 
    begin
        ss_wr1 <= ss_wr;
        ss_wr2 <= ss_wr1;
    end 
end
wire ss_r;
assign ss_r = ss_wr || ss_dr;

wire ValidRange_r;
assign ValidRange_r = ss_wr2 || ss_dr;
reg ss_r1;
reg ss_r2;
always@(posedge clk1)
begin
    if(reset)  
    begin
        ss_r1 <= 1'b1;
        ss_r2 <= 1'b1;
    end
    else 
    begin
        ss_r1 <= ValidRange_r;
        ss_r2 <= ss_r1;
    end 
end

reg [7 : 0] data_spi;     // spi data input
reg [6 : 0] data_spi_cnt;  // [5 : 0]->2, [6 : 0] ->4

always @(posedge clk1)
if (ValidRange_r | reset)
begin
    data_spi_cnt <= 5'b0;
end
else
begin
    data_spi_cnt <= data_spi_cnt + 1'b1;  
end

reg valid_spi;
always @(posedge clk1)
if (reset)
begin
    data_spi <= 8'b0;
   // data_spi_cnt <= 4'b0;               //mutl_driven
   // data_addr_cnt <= 32'b0;
    valid_spi <= 1'b0;
end
else if (~ValidRange_r)
begin   
    if(data_spi_cnt == 4'b1)
    begin
        valid_spi <= 1'b1;
        data_spi <= data_spi_32[31 : 24];   // ´Ó¸ßµ½µÍ·¢ËÍ
    end
    else if(data_spi_cnt == 7'd33)
        begin
            valid_spi <= 1'b1;
            data_spi <= data_spi_32[23 : 16];
        end
        else if(data_spi_cnt == 7'd65)
            begin
                valid_spi <= 1'b1;
                data_spi <= data_spi_32[15 : 8];
            end
            else if(data_spi_cnt == 7'd97)
                begin
                    valid_spi <= 1'b1;
                    data_spi <= data_spi_32[7 : 0];
                end
                else
                begin
                    valid_spi <= 1'b0;
                end
               
end
else
begin
    valid_spi <= 1'b0;  
end 
wire valid_spi_o;
assign valid_spi_o = valid_spi && (~ss_r);   


assign DVALID = valid_spi_o;
assign DOUT   = data_spi ;  
assign ValidRange = ss_r2;       


endmodule

