`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2024/03/26 15:21:07
// Design Name: 
// Module Name: spi_master_mem
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module spi_master_mem(
    clk,     
    reset,
    RD,         // axi
    ADDR_RD,    // axi
    DIN,        // spi
    DVALID,     // spi
    cmd_s,
    chirpID,
    Nlen,
    data_spi_32,
    
    DREADY,
    
    DOUT,
    DVALID_o
);

parameter                    MEM_WORDS = 1000;

input                        clk;
input                        reset;
input                        RD;
input [31:0]                 ADDR_RD;
input [7:0]                  DIN;
input                        DVALID;
input                        cmd_s;    // Ö¡¸ñÊ½¿ØÖÆ×Ö
input [4 :0]                 chirpID;
input [31:0]                 Nlen;
input [31 :0]                data_spi_32;   // ×ÖÍ·

input                        DREADY;

output [31:0]                DOUT;
output                       DVALID_o;


reg DREADY_r;
always @(posedge clk)
begin
    if(reset)
        DREADY_r <= 1'b0;
    else 
        DREADY_r <= DREADY;
end

reg [1  : 0] valid_cnt;  // valid count,ÒÔ4ÎªÖÜÆÚ
reg [5  : 0] valid_cnt16; // valid count, ÒÔ16*4ÎªÖÜÆÚ
reg [31  : 0] head_cnt;    // Ö¡¼ÆÊý
wire [31 : 0] Length;      // Ö¡³¤¶È
//assign Length = (cmd_s == 1'b0) ? 8'd7 : 8'd67; // 7 = 2*4 -1; 67 = 17 * 4 -1
assign Length = (Nlen + 1) * 4 - 1;
reg [31 : 0] data_32;      
always @(posedge clk)
begin
  if (reset || (~RD) || (~DREADY_r))
  begin
    valid_cnt   <= 2'b0; 
    valid_cnt16 <= 4'b0;
    data_32     <= 32'b0; 
  end
  else if(RD && DREADY_r && DVALID)
  begin  
    begin
        valid_cnt   <= valid_cnt + 1'b1; 
        valid_cnt16 <= valid_cnt16 + 1'b1;
    end

    if(valid_cnt == 2'b0)                     
    begin
        data_32   <=  {DIN, data_32[23 : 0]};    // MSB
    end
    else if(valid_cnt == 2'd1)
    begin
        data_32   <=  {data_32[31 : 24], DIN, data_32[15 : 0]}; 
    end
    else if(valid_cnt == 2'd2)
    begin
        data_32   <=  {data_32[31 : 16], DIN, data_32[7 : 0]}; 
    end
    else if(valid_cnt == 2'd3)
    begin
        data_32   <=  {data_32[31 : 8], DIN}; 
    end 
  end
end

always @(posedge clk)
begin
  if (reset || (~RD) || (~DREADY_r))
  begin
    head_cnt   <= 32'b0; 
  end
  else if(RD && DREADY_r && DVALID)
  begin 
    if(head_cnt < Length) 
    begin
        head_cnt   <= head_cnt + 1'b1; 
    end
    else 
    begin
        head_cnt   <= 32'b0;
    end

  end
end

reg DVALID_r;
always@(posedge clk)
begin
    if(reset)
    begin
        DVALID_r   <= 1'b0; 
    end
    else
    begin
        DVALID_r   <= DVALID;
    end
end

reg [31 : 0] data_o;
reg valid_o;
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ÓÉÓÚspi masterÄ£¿éµÄ´¦Àí£¬ÕâÀïµÄÊý¾Ý±Èaxi_slave_mem ·¢³öµÄÊý¾ÝÒªÍíÒ»Ð©£¬ÐèÒªÑÓÊ±ÒÔ¶ÔÆë
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
reg [31 : 0] data_spi_32_r1;
reg [31 : 0] data_spi_32_r2;
reg [31 : 0] data_spi_32_r3;
reg [31 : 0] data_spi_32_r4;
reg [31 : 0] data_spi_32_r5;
reg [31 : 0] data_spi_32_r6;
reg [31 : 0] data_spi_32_r7;
reg [31 : 0] data_spi_32_r8;
always@(posedge clk)
begin
    if(reset)
    begin
        data_spi_32_r1 <= 32'b0;
        data_spi_32_r2 <= 32'b0;
        data_spi_32_r3 <= 32'b0;
        data_spi_32_r4 <= 32'b0;
        data_spi_32_r5 <= 32'b0;
        data_spi_32_r6 <= 32'b0;
        data_spi_32_r7 <= 32'b0;
        data_spi_32_r8 <= 32'b0;   
    end
    else
    begin
        data_spi_32_r1 <= data_spi_32;
        data_spi_32_r2 <= data_spi_32_r1;
        data_spi_32_r3 <= data_spi_32_r2;
        data_spi_32_r4 <= data_spi_32_r3;
        data_spi_32_r5 <= data_spi_32_r4;
        data_spi_32_r6 <= data_spi_32_r5;
        data_spi_32_r7 <= data_spi_32_r6;
        data_spi_32_r8 <= data_spi_32_r7;  
    end
end

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// spi slave ·µ»ØÊý¾ÝÔÚÖ¡Í·´¦·µ»ØÈ«Áã£¬²»ÐèÑÓºóÊý¾Ý£¬ÔÚÈ«Áã´¦²ðÈëÖ¡Í·¼´¿É
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
always@(posedge clk)
begin
if(reset || (~RD) || (~DREADY_r))
begin
    data_o <= 32'b0;
    valid_o <= 1'b0;
end
begin
    if(DVALID_r && (valid_cnt == 2'd0) && (RD) ) //&& DREADY
        begin
        if(head_cnt == 32'd4)  // Ã¿Ö¡Ç°4¸ö×Ö½ÚÊÇÖ¡Í·
        begin
            data_o <= data_spi_32_r8;
            valid_o <= 1'b1;
        end
        else
        begin
            data_o <= data_32;
            valid_o <= 1'b1;
        end
        end
     else
     begin
            valid_o <= 1'b0;
     end
end

end



assign DOUT = data_o;    
assign DVALID_o = valid_o;


endmodule

